﻿// <auto-generated />
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Metadata;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage;
using Microsoft.EntityFrameworkCore.Storage.Internal;
using SEINN.Data.EntityFramework;
using System;

namespace SEINN.Data.EntityFramework.Migrations
{
    [DbContext(typeof(SEINNDbContext))]
    [Migration("20180306113341_ProductRelationship")]
    partial class ProductRelationship
    {
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.SerialColumn)
                .HasAnnotation("ProductVersion", "2.0.1-rtm-125");

            modelBuilder.Entity("SIENN.Domain.Data.Model.Category", b =>
                {
                    b.Property<string>("Code")
                        .ValueGeneratedOnAdd()
                        .HasColumnName("Code")
                        .HasColumnType("varchar(255)");

                    b.Property<string>("Description")
                        .HasColumnName("Description")
                        .HasColumnType("text");

                    b.HasKey("Code");

                    b.ToTable("Categories");
                });

            modelBuilder.Entity("SIENN.Domain.Data.Model.Product", b =>
                {
                    b.Property<string>("Code")
                        .ValueGeneratedOnAdd()
                        .HasColumnName("Code")
                        .HasColumnType("varchar(255)");

                    b.Property<DateTime>("DeliveryDate")
                        .HasColumnName("DeliveryDate")
                        .HasColumnType("date");

                    b.Property<string>("Description")
                        .HasColumnName("Description")
                        .HasColumnType("text");

                    b.Property<bool>("IsAvailabale")
                        .HasColumnName("IsAvailable")
                        .HasColumnType("Boolean");

                    b.Property<decimal>("Price")
                        .HasColumnType("decimal(7,2)");

                    b.Property<string>("TypeCode")
                        .IsRequired();

                    b.Property<string>("UnitCode")
                        .IsRequired();

                    b.HasKey("Code");

                    b.HasIndex("TypeCode");

                    b.HasIndex("UnitCode");

                    b.ToTable("Products");
                });

            modelBuilder.Entity("SIENN.Domain.Data.Model.ProductCategory", b =>
                {
                    b.Property<string>("ProductCode");

                    b.Property<string>("CategoryCode");

                    b.HasKey("ProductCode", "CategoryCode");

                    b.HasIndex("CategoryCode");

                    b.ToTable("ProductsCategories");
                });

            modelBuilder.Entity("SIENN.Domain.Data.Model.ProductType", b =>
                {
                    b.Property<string>("Code")
                        .ValueGeneratedOnAdd()
                        .HasColumnName("Code")
                        .HasColumnType("varchar(255)");

                    b.Property<string>("Description")
                        .HasColumnName("Description")
                        .HasColumnType("text");

                    b.HasKey("Code");

                    b.ToTable("Types");
                });

            modelBuilder.Entity("SIENN.Domain.Data.Model.ProductUnit", b =>
                {
                    b.Property<string>("Code")
                        .ValueGeneratedOnAdd()
                        .HasColumnName("Code")
                        .HasColumnType("varchar(255)");

                    b.Property<string>("Description")
                        .HasColumnName("Description")
                        .HasColumnType("text");

                    b.HasKey("Code");

                    b.ToTable("Units");
                });

            modelBuilder.Entity("SIENN.Domain.Data.Model.Product", b =>
                {
                    b.HasOne("SIENN.Domain.Data.Model.ProductType", "Type")
                        .WithMany()
                        .HasForeignKey("TypeCode")
                        .OnDelete(DeleteBehavior.Restrict);

                    b.HasOne("SIENN.Domain.Data.Model.ProductUnit", "Unit")
                        .WithMany()
                        .HasForeignKey("UnitCode")
                        .OnDelete(DeleteBehavior.Restrict);
                });

            modelBuilder.Entity("SIENN.Domain.Data.Model.ProductCategory", b =>
                {
                    b.HasOne("SIENN.Domain.Data.Model.Category", "Category")
                        .WithMany("Products")
                        .HasForeignKey("CategoryCode")
                        .OnDelete(DeleteBehavior.Restrict);

                    b.HasOne("SIENN.Domain.Data.Model.Product", "Product")
                        .WithMany("Categories")
                        .HasForeignKey("ProductCode")
                        .OnDelete(DeleteBehavior.Cascade);
                });
#pragma warning restore 612, 618
        }
    }
}
